/* contacts-in-app-notification.c generated by valac 0.37.1.6-1eaec, the Vala compiler
 * generated from contacts-in-app-notification.vala, do not modify */

/*
 * Copyright (C) 2017 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define CONTACTS_TYPE_IN_APP_NOTIFICATION (contacts_in_app_notification_get_type ())
#define CONTACTS_IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification))
#define CONTACTS_IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotificationClass))
#define CONTACTS_IS_IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION))
#define CONTACTS_IS_IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_IN_APP_NOTIFICATION))
#define CONTACTS_IN_APP_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotificationClass))

typedef struct _ContactsInAppNotification ContactsInAppNotification;
typedef struct _ContactsInAppNotificationClass ContactsInAppNotificationClass;
typedef struct _ContactsInAppNotificationPrivate ContactsInAppNotificationPrivate;
enum  {
	CONTACTS_IN_APP_NOTIFICATION_DUMMY_PROPERTY,
	CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL,
	CONTACTS_IN_APP_NOTIFICATION_LAST_PROPERTY
};
static GParamSpec* contacts_in_app_notification_properties[CONTACTS_IN_APP_NOTIFICATION_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL,
	CONTACTS_IN_APP_NOTIFICATION_LAST_SIGNAL
};
static guint contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_LAST_SIGNAL] = {0};

struct _ContactsInAppNotification {
	GtkRevealer parent_instance;
	ContactsInAppNotificationPrivate * priv;
};

struct _ContactsInAppNotificationClass {
	GtkRevealerClass parent_class;
};

struct _ContactsInAppNotificationPrivate {
	GtkGrid* grid;
	GtkLabel* label;
};


static gpointer contacts_in_app_notification_parent_class = NULL;

GType contacts_in_app_notification_get_type (void) G_GNUC_CONST;
#define CONTACTS_IN_APP_NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotificationPrivate))
#define CONTACTS_IN_APP_NOTIFICATION_DEFAULT_KEEPALIVE ((guint) 5)
ContactsInAppNotification* contacts_in_app_notification_new (const gchar* message, GtkButton* button);
ContactsInAppNotification* contacts_in_app_notification_construct (GType object_type, const gchar* message, GtkButton* button);
static void contacts_in_app_notification_on_child_revealed_changed (ContactsInAppNotification* self, GObject* o, GParamSpec* p);
static void _contacts_in_app_notification_on_child_revealed_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void contacts_in_app_notification_show (ContactsInAppNotification* self);
static gboolean __lambda76_ (ContactsInAppNotification* self);
void contacts_in_app_notification_dismiss (ContactsInAppNotification* self);
static gboolean ___lambda76__gsource_func (gpointer self);
static void contacts_in_app_notification_on_close_button_clicked (ContactsInAppNotification* self, GtkButton* close_button);
static void _contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
GtkLabel* contacts_in_app_notification_get_message_label (ContactsInAppNotification* self);
static void contacts_in_app_notification_finalize (GObject * obj);
static void _vala_contacts_in_app_notification_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


/**
   * Creates an in-app notification with the given message, and an accompanying button if not null.
   */
static void _contacts_in_app_notification_on_child_revealed_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 50 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_on_child_revealed_changed ((ContactsInAppNotification*) self, _sender, pspec);
#line 93 "contacts-in-app-notification.c"
}


ContactsInAppNotification* contacts_in_app_notification_construct (GType object_type, const gchar* message, GtkButton* button) {
	ContactsInAppNotification * self = NULL;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	GtkButton* _tmp2_;
#line 42 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 42 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	self = (ContactsInAppNotification*) g_object_new (object_type, NULL);
#line 43 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp0_ = self->priv->label;
#line 43 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp1_ = message;
#line 43 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 45 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp2_ = button;
#line 45 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	if (_tmp2_ != NULL) {
#line 116 "contacts-in-app-notification.c"
		GtkGrid* _tmp3_;
		GtkButton* _tmp4_;
		GtkButton* _tmp5_;
#line 46 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		_tmp3_ = self->priv->grid;
#line 46 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		_tmp4_ = button;
#line 46 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		gtk_grid_attach (_tmp3_, (GtkWidget*) _tmp4_, 1, 0, 1, 1);
#line 47 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		_tmp5_ = button;
#line 47 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		gtk_widget_show ((GtkWidget*) _tmp5_);
#line 130 "contacts-in-app-notification.c"
	}
#line 50 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_signal_connect_object ((GObject*) self, "notify::child-revealed", (GCallback) _contacts_in_app_notification_on_child_revealed_changed_g_object_notify, self, 0);
#line 42 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	return self;
#line 136 "contacts-in-app-notification.c"
}


ContactsInAppNotification* contacts_in_app_notification_new (const gchar* message, GtkButton* button) {
#line 42 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	return contacts_in_app_notification_construct (CONTACTS_TYPE_IN_APP_NOTIFICATION, message, button);
#line 143 "contacts-in-app-notification.c"
}


static gboolean __lambda76_ (ContactsInAppNotification* self) {
	gboolean result = FALSE;
#line 58 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_dismiss (self);
#line 59 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	result = FALSE;
#line 59 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	return result;
#line 155 "contacts-in-app-notification.c"
}


static gboolean ___lambda76__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda76_ ((ContactsInAppNotification*) self);
#line 57 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	return result;
#line 164 "contacts-in-app-notification.c"
}


void contacts_in_app_notification_show (ContactsInAppNotification* self) {
#line 53 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 54 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	GTK_WIDGET_CLASS (contacts_in_app_notification_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer));
#line 55 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
#line 57 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, CONTACTS_IN_APP_NOTIFICATION_DEFAULT_KEEPALIVE, ___lambda76__gsource_func, g_object_ref (self), g_object_unref);
#line 177 "contacts-in-app-notification.c"
}


void contacts_in_app_notification_dismiss (ContactsInAppNotification* self) {
#line 63 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 64 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, FALSE);
#line 186 "contacts-in-app-notification.c"
}


static void contacts_in_app_notification_on_child_revealed_changed (ContactsInAppNotification* self, GObject* o, GParamSpec* p) {
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 67 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 67 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (o != NULL);
#line 67 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (p != NULL);
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp0_ = gtk_revealer_get_child_revealed ((GtkRevealer*) self);
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp1_ = _tmp0_;
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	if (!_tmp1_) {
#line 69 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		g_signal_emit (self, contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL], 0);
#line 70 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 209 "contacts-in-app-notification.c"
	}
}


static void contacts_in_app_notification_on_close_button_clicked (ContactsInAppNotification* self, GtkButton* close_button) {
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_if_fail (close_button != NULL);
#line 76 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_dismiss (self);
#line 221 "contacts-in-app-notification.c"
}


static void _contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_on_close_button_clicked ((ContactsInAppNotification*) self, _sender);
#line 228 "contacts-in-app-notification.c"
}


GtkLabel* contacts_in_app_notification_get_message_label (ContactsInAppNotification* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_;
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_tmp0_ = self->priv->label;
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	result = _tmp0_;
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	return result;
#line 243 "contacts-in-app-notification.c"
}


static void contacts_in_app_notification_class_init (ContactsInAppNotificationClass * klass) {
	gint ContactsInAppNotification_private_offset;
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_parent_class = g_type_class_peek_parent (klass);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_type_class_add_private (klass, sizeof (ContactsInAppNotificationPrivate));
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_in_app_notification_get_property;
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_in_app_notification_finalize;
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL, contacts_in_app_notification_properties[CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL] = g_param_spec_object ("message-label", "message-label", "message-label", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	ContactsInAppNotification_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/contacts/ui/contacts-in-app-notification.ui");
#line 263 "contacts-in-app-notification.c"
	/**
	   * Fired when the notification is completely dismissed (i.e. gone).
	   */
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL] = g_signal_new ("dismissed", CONTACTS_TYPE_IN_APP_NOTIFICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "grid", FALSE, ContactsInAppNotification_private_offset + G_STRUCT_OFFSET (ContactsInAppNotificationPrivate, grid));
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label", FALSE, ContactsInAppNotification_private_offset + G_STRUCT_OFFSET (ContactsInAppNotificationPrivate, label));
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_close_button_clicked", G_CALLBACK(_contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked));
#line 275 "contacts-in-app-notification.c"
}


static void contacts_in_app_notification_instance_init (ContactsInAppNotification * self) {
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	self->priv = CONTACTS_IN_APP_NOTIFICATION_GET_PRIVATE (self);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 284 "contacts-in-app-notification.c"
}


static void contacts_in_app_notification_finalize (GObject * obj) {
	ContactsInAppNotification * self;
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification);
#line 26 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_g_object_unref0 (self->priv->grid);
#line 29 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	_g_object_unref0 (self->priv->label);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (contacts_in_app_notification_parent_class)->finalize (obj);
#line 298 "contacts-in-app-notification.c"
}


GType contacts_in_app_notification_get_type (void) {
	static volatile gsize contacts_in_app_notification_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_in_app_notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsInAppNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_in_app_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsInAppNotification), 0, (GInstanceInitFunc) contacts_in_app_notification_instance_init, NULL };
		GType contacts_in_app_notification_type_id;
		contacts_in_app_notification_type_id = g_type_register_static (gtk_revealer_get_type (), "ContactsInAppNotification", &g_define_type_info, 0);
		g_once_init_leave (&contacts_in_app_notification_type_id__volatile, contacts_in_app_notification_type_id);
	}
	return contacts_in_app_notification_type_id__volatile;
}


static void _vala_contacts_in_app_notification_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ContactsInAppNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
	switch (property_id) {
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		case CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL:
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		g_value_set_object (value, contacts_in_app_notification_get_message_label (self));
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		break;
#line 325 "contacts-in-app-notification.c"
		default:
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-in-app-notification.vala"
		break;
#line 331 "contacts-in-app-notification.c"
	}
}



