/* contacts-list-pane.c generated by valac 0.37.1.6-1eaec, the Vala compiler
 * generated from contacts-list-pane.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 8 -*- */
/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define CONTACTS_TYPE_LIST_PANE (contacts_list_pane_get_type ())
#define CONTACTS_LIST_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_LIST_PANE, ContactsListPane))
#define CONTACTS_LIST_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_LIST_PANE, ContactsListPaneClass))
#define CONTACTS_IS_LIST_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_LIST_PANE))
#define CONTACTS_IS_LIST_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_LIST_PANE))
#define CONTACTS_LIST_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_LIST_PANE, ContactsListPaneClass))

typedef struct _ContactsListPane ContactsListPane;
typedef struct _ContactsListPaneClass ContactsListPaneClass;
typedef struct _ContactsListPanePrivate ContactsListPanePrivate;

#define CONTACTS_TYPE_STORE (contacts_store_get_type ())
#define CONTACTS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_STORE, ContactsStore))
#define CONTACTS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_STORE, ContactsStoreClass))
#define CONTACTS_IS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_STORE))
#define CONTACTS_IS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_STORE))
#define CONTACTS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_STORE, ContactsStoreClass))

typedef struct _ContactsStore ContactsStore;
typedef struct _ContactsStoreClass ContactsStoreClass;

#define CONTACTS_TYPE_VIEW (contacts_view_get_type ())
#define CONTACTS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_VIEW, ContactsView))
#define CONTACTS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_VIEW, ContactsViewClass))
#define CONTACTS_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_VIEW))
#define CONTACTS_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_VIEW))
#define CONTACTS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_VIEW, ContactsViewClass))

typedef struct _ContactsView ContactsView;
typedef struct _ContactsViewClass ContactsViewClass;
enum  {
	CONTACTS_LIST_PANE_DUMMY_PROPERTY,
	CONTACTS_LIST_PANE_STORE,
	CONTACTS_LIST_PANE_LAST_PROPERTY
};
static GParamSpec* contacts_list_pane_properties[CONTACTS_LIST_PANE_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define CONTACTS_TYPE_CONTACT (contacts_contact_get_type ())
#define CONTACTS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT, ContactsContact))
#define CONTACTS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT, ContactsContactClass))
#define CONTACTS_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT))
#define CONTACTS_IS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT))
#define CONTACTS_CONTACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT, ContactsContactClass))

typedef struct _ContactsContact ContactsContact;
typedef struct _ContactsContactClass ContactsContactClass;
enum  {
	CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL,
	CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL,
	CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL,
	CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL,
	CONTACTS_LIST_PANE_LAST_SIGNAL
};
static guint contacts_list_pane_signals[CONTACTS_LIST_PANE_LAST_SIGNAL] = {0};

struct _ContactsListPane {
	GtkFrame parent_instance;
	ContactsListPanePrivate * priv;
	GtkToolItem* search_tool_item;
	GtkSearchEntry* filter_entry;
	GtkButton* link_button;
	GtkButton* delete_button;
	GtkActionBar* actions_bar;
};

struct _ContactsListPaneClass {
	GtkFrameClass parent_class;
};

struct _ContactsListPanePrivate {
	ContactsStore* _store;
	ContactsView* contacts_view;
	guint filter_entry_changed_id;
	gboolean ignore_selection_change;
};


static gpointer contacts_list_pane_parent_class = NULL;

GType contacts_list_pane_get_type (void) G_GNUC_CONST;
GType contacts_store_get_type (void) G_GNUC_CONST;
GType contacts_view_get_type (void) G_GNUC_CONST;
#define CONTACTS_LIST_PANE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTACTS_TYPE_LIST_PANE, ContactsListPanePrivate))
void contacts_list_pane_refilter (ContactsListPane* self);
gboolean contacts_utils_string_is_empty (const gchar* str);
gchar* contacts_utils_canonicalize_for_search (const gchar* str);
void contacts_view_set_filter_values (ContactsView* self, gchar** values, int values_length1);
static gboolean contacts_list_pane_filter_entry_changed_timeout (ContactsListPane* self);
static void contacts_list_pane_filter_entry_changed (ContactsListPane* self, GtkEditable* editable);
static gboolean _contacts_list_pane_filter_entry_changed_timeout_gsource_func (gpointer self);
static void _contacts_list_pane_filter_entry_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
ContactsListPane* contacts_list_pane_new (ContactsStore* contacts_store);
ContactsListPane* contacts_list_pane_construct (GType object_type, ContactsStore* contacts_store);
GType contacts_contact_get_type (void) G_GNUC_CONST;
void contacts_list_pane_select_contact (ContactsListPane* self, ContactsContact* contact, gboolean ignore_change);
void contacts_view_select_contact (ContactsView* self, ContactsContact* contact);
void contacts_list_pane_show_selection (ContactsListPane* self);
void contacts_view_show_selectors (ContactsView* self);
void contacts_list_pane_hide_selection (ContactsListPane* self);
void contacts_view_hide_selectors (ContactsView* self);
static void contacts_list_pane_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width);
ContactsStore* contacts_list_pane_get_store (ContactsListPane* self);
void contacts_list_pane_set_store (ContactsListPane* self, ContactsStore* value);
void contacts_view_set_store (ContactsView* self, ContactsStore* value);
static GObject * contacts_list_pane_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _contacts_list_pane___lambda81_ (ContactsListPane* self, ContactsView* l, ContactsContact* contact);
static void __contacts_list_pane___lambda81__contacts_view_selection_changed (ContactsView* _sender, ContactsContact* contact, gpointer self);
static void _contacts_list_pane___lambda82_ (ContactsListPane* self, gint nr_contacts_marked);
static void __contacts_list_pane___lambda82__contacts_view_contacts_marked (ContactsView* _sender, gint contacts_marked, gpointer self);
static void _contacts_list_pane___lambda83_ (ContactsListPane* self);
GeeLinkedList* contacts_view_get_marked_contacts (ContactsView* self);
static void __contacts_list_pane___lambda83__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _contacts_list_pane___lambda84_ (ContactsListPane* self);
void contacts_contact_hide (ContactsContact* self);
static void __contacts_list_pane___lambda84__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void contacts_list_pane_finalize (GObject * obj);
static void _vala_contacts_list_pane_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_contacts_list_pane_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void contacts_list_pane_refilter (ContactsListPane* self) {
	gchar** values = NULL;
	gint values_length1 = 0;
	gint _values_size_ = 0;
	gchar* str = NULL;
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	ContactsView* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
#line 64 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 66 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->filter_entry;
#line 66 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 66 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 66 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	str = _tmp2_;
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp3_ = str;
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp4_ = contacts_utils_string_is_empty (_tmp3_);
#line 68 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (_tmp4_) {
#line 69 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 69 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values = NULL;
#line 69 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values_length1 = 0;
#line 69 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_values_size_ = values_length1;
#line 193 "contacts-list-pane.c"
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
#line 71 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp5_ = str;
#line 71 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp6_ = contacts_utils_canonicalize_for_search (_tmp5_);
#line 71 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_g_free0 (str);
#line 71 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		str = _tmp6_;
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp7_ = str;
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values = _tmp9_;
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		values_length1 = _vala_array_length (_tmp8_);
#line 72 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_values_size_ = values_length1;
#line 220 "contacts-list-pane.c"
	}
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp10_ = self->priv->contacts_view;
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp11_ = values;
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp11__length1 = values_length1;
#line 75 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_view_set_filter_values (_tmp10_, _tmp11_, _tmp11__length1);
#line 64 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_free0 (str);
#line 64 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 234 "contacts-list-pane.c"
}


static gboolean contacts_list_pane_filter_entry_changed_timeout (ContactsListPane* self) {
	gboolean result = FALSE;
#line 78 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self->priv->filter_entry_changed_id = (guint) 0;
#line 80 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_refilter (self);
#line 81 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	result = FALSE;
#line 81 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return result;
#line 250 "contacts-list-pane.c"
}


static gboolean _contacts_list_pane_filter_entry_changed_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = contacts_list_pane_filter_entry_changed_timeout ((ContactsListPane*) self);
#line 89 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return result;
#line 259 "contacts-list-pane.c"
}


static void contacts_list_pane_filter_entry_changed (ContactsListPane* self, GtkEditable* editable) {
	guint _tmp0_;
	guint _tmp2_;
#line 85 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 85 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (editable != NULL);
#line 86 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->filter_entry_changed_id;
#line 86 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 274 "contacts-list-pane.c"
		guint _tmp1_;
#line 87 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp1_ = self->priv->filter_entry_changed_id;
#line 87 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		g_source_remove (_tmp1_);
#line 280 "contacts-list-pane.c"
	}
#line 89 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _contacts_list_pane_filter_entry_changed_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 89 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self->priv->filter_entry_changed_id = _tmp2_;
#line 286 "contacts-list-pane.c"
}


static void _contacts_list_pane_filter_entry_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_filter_entry_changed ((ContactsListPane*) self, _sender);
#line 293 "contacts-list-pane.c"
}


ContactsListPane* contacts_list_pane_construct (GType object_type, ContactsStore* contacts_store) {
	ContactsListPane * self = NULL;
	ContactsStore* _tmp0_;
#line 92 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_val_if_fail (contacts_store != NULL, NULL);
#line 93 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = contacts_store;
#line 93 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self = (ContactsListPane*) g_object_new (object_type, "store", _tmp0_, NULL);
#line 92 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return self;
#line 308 "contacts-list-pane.c"
}


ContactsListPane* contacts_list_pane_new (ContactsStore* contacts_store) {
#line 92 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return contacts_list_pane_construct (CONTACTS_TYPE_LIST_PANE, contacts_store);
#line 315 "contacts-list-pane.c"
}


void contacts_list_pane_select_contact (ContactsListPane* self, ContactsContact* contact, gboolean ignore_change) {
	gboolean _tmp0_;
	ContactsView* _tmp1_;
	ContactsContact* _tmp2_;
#line 135 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 136 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = ignore_change;
#line 136 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (_tmp0_) {
#line 137 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		self->priv->ignore_selection_change = TRUE;
#line 331 "contacts-list-pane.c"
	}
#line 138 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = self->priv->contacts_view;
#line 138 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = contact;
#line 138 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_view_select_contact (_tmp1_, _tmp2_);
#line 139 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self->priv->ignore_selection_change = FALSE;
#line 341 "contacts-list-pane.c"
}


void contacts_list_pane_show_selection (ContactsListPane* self) {
	ContactsView* _tmp0_;
	GtkActionBar* _tmp1_;
#line 142 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 143 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_view;
#line 143 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_view_show_selectors (_tmp0_);
#line 144 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = self->actions_bar;
#line 144 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 358 "contacts-list-pane.c"
}


void contacts_list_pane_hide_selection (ContactsListPane* self) {
	ContactsView* _tmp0_;
	GtkActionBar* _tmp1_;
#line 147 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 148 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_view;
#line 148 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_view_hide_selectors (_tmp0_);
#line 149 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = self->actions_bar;
#line 149 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 375 "contacts-list-pane.c"
}


static void contacts_list_pane_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width) {
	ContactsListPane * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 153 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self = (ContactsListPane*) base;
#line 154 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_vala_natural_width = 300;
#line 154 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_vala_minimum_width = _vala_natural_width;
#line 153 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (minimum_width) {
#line 153 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		*minimum_width = _vala_minimum_width;
#line 393 "contacts-list-pane.c"
	}
#line 153 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (natural_width) {
#line 153 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		*natural_width = _vala_natural_width;
#line 399 "contacts-list-pane.c"
	}
}


ContactsStore* contacts_list_pane_get_store (ContactsListPane* self) {
	ContactsStore* result;
	ContactsStore* _tmp0_;
#line 27 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->_store;
#line 28 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	result = _tmp0_;
#line 28 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return result;
#line 415 "contacts-list-pane.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return self ? g_object_ref (self) : NULL;
#line 422 "contacts-list-pane.c"
}


void contacts_list_pane_set_store (ContactsListPane* self, ContactsStore* value) {
	ContactsStore* _tmp0_;
	ContactsStore* _tmp1_;
	ContactsView* _tmp2_;
	ContactsStore* _tmp3_;
#line 30 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = value;
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->_store);
#line 31 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self->priv->_store = _tmp1_;
#line 32 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = self->priv->contacts_view;
#line 32 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp3_ = self->priv->_store;
#line 32 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_view_set_store (_tmp2_, _tmp3_);
#line 30 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_object_notify_by_pspec ((GObject *) self, contacts_list_pane_properties[CONTACTS_LIST_PANE_STORE]);
#line 449 "contacts-list-pane.c"
}


static void _contacts_list_pane___lambda81_ (ContactsListPane* self, ContactsView* l, ContactsContact* contact) {
	gboolean _tmp0_;
#line 99 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_return_if_fail (l != NULL);
#line 100 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->ignore_selection_change;
#line 100 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (!_tmp0_) {
#line 461 "contacts-list-pane.c"
		ContactsContact* _tmp1_;
#line 101 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp1_ = contact;
#line 101 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL], 0, _tmp1_);
#line 467 "contacts-list-pane.c"
	}
}


static void __contacts_list_pane___lambda81__contacts_view_selection_changed (ContactsView* _sender, ContactsContact* contact, gpointer self) {
#line 99 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_contacts_list_pane___lambda81_ ((ContactsListPane*) self, _sender, contact);
#line 475 "contacts-list-pane.c"
}


static void _contacts_list_pane___lambda82_ (ContactsListPane* self, gint nr_contacts_marked) {
	gint _tmp0_;
	gint _tmp3_;
	gint _tmp6_;
#line 106 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = nr_contacts_marked;
#line 106 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (_tmp0_ > 0) {
#line 487 "contacts-list-pane.c"
		GtkButton* _tmp1_;
#line 107 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp1_ = self->delete_button;
#line 107 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 493 "contacts-list-pane.c"
	} else {
		GtkButton* _tmp2_;
#line 109 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp2_ = self->delete_button;
#line 109 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 500 "contacts-list-pane.c"
	}
#line 111 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp3_ = nr_contacts_marked;
#line 111 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	if (_tmp3_ > 1) {
#line 506 "contacts-list-pane.c"
		GtkButton* _tmp4_;
#line 112 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp4_ = self->link_button;
#line 112 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 512 "contacts-list-pane.c"
	} else {
		GtkButton* _tmp5_;
#line 114 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp5_ = self->link_button;
#line 114 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 519 "contacts-list-pane.c"
	}
#line 116 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp6_ = nr_contacts_marked;
#line 116 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL], 0, _tmp6_);
#line 525 "contacts-list-pane.c"
}


static void __contacts_list_pane___lambda82__contacts_view_contacts_marked (ContactsView* _sender, gint contacts_marked, gpointer self) {
#line 105 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_contacts_list_pane___lambda82_ ((ContactsListPane*) self, contacts_marked);
#line 532 "contacts-list-pane.c"
}


static void _contacts_list_pane___lambda83_ (ContactsListPane* self) {
	GeeLinkedList* marked_contacts = NULL;
	ContactsView* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 120 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_view;
#line 120 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = contacts_view_get_marked_contacts (_tmp0_);
#line 120 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	marked_contacts = _tmp1_;
#line 122 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = marked_contacts;
#line 122 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL], 0, _tmp2_);
#line 119 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (marked_contacts);
#line 553 "contacts-list-pane.c"
}


static void __contacts_list_pane___lambda83__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 119 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_contacts_list_pane___lambda83_ ((ContactsListPane*) self);
#line 560 "contacts-list-pane.c"
}


static void _contacts_list_pane___lambda84_ (ContactsListPane* self) {
	GeeLinkedList* marked_contacts = NULL;
	ContactsView* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp14_;
#line 126 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_view;
#line 126 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = contacts_view_get_marked_contacts (_tmp0_);
#line 126 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	marked_contacts = _tmp1_;
#line 575 "contacts-list-pane.c"
	{
		GeeLinkedList* _c_list = NULL;
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
		gint _c_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _c_index = 0;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp2_ = marked_contacts;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_c_list = _tmp3_;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp4_ = _c_list;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_tmp6_ = _tmp5_;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_c_size = _tmp6_;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_c_index = -1;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		while (TRUE) {
#line 603 "contacts-list-pane.c"
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			ContactsContact* c = NULL;
			GeeLinkedList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			ContactsContact* _tmp13_;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp7_ = _c_index;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_c_index = _tmp7_ + 1;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp8_ = _c_index;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp9_ = _c_size;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
				break;
#line 624 "contacts-list-pane.c"
			}
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp10_ = _c_list;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp11_ = _c_index;
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			c = (ContactsContact*) _tmp12_;
#line 128 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_tmp13_ = c;
#line 128 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			contacts_contact_hide (_tmp13_);
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
			_g_object_unref0 (c);
#line 640 "contacts-list-pane.c"
		}
#line 127 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		_g_object_unref0 (_c_list);
#line 644 "contacts-list-pane.c"
	}
#line 131 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp14_ = marked_contacts;
#line 131 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL], 0, _tmp14_);
#line 125 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (marked_contacts);
#line 652 "contacts-list-pane.c"
}


static void __contacts_list_pane___lambda84__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 125 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_contacts_list_pane___lambda84_ ((ContactsListPane*) self);
#line 659 "contacts-list-pane.c"
}


static GObject * contacts_list_pane_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ContactsListPane * self;
	GtkToolItem* _tmp0_;
	ContactsView* _tmp1_;
	ContactsView* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
#line 96 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	parent_class = G_OBJECT_CLASS (contacts_list_pane_parent_class);
#line 96 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 96 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 97 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp0_ = self->search_tool_item;
#line 97 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_tool_item_set_expand (_tmp0_, TRUE);
#line 99 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp1_ = self->priv->contacts_view;
#line 99 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp1_, "selection-changed", (GCallback) __contacts_list_pane___lambda81__contacts_view_selection_changed, self, 0);
#line 105 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp2_ = self->priv->contacts_view;
#line 105 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp2_, "contacts-marked", (GCallback) __contacts_list_pane___lambda82__contacts_view_contacts_marked, self, 0);
#line 119 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp3_ = self->link_button;
#line 119 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) __contacts_list_pane___lambda83__gtk_button_clicked, self, 0);
#line 125 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_tmp4_ = self->delete_button;
#line 125 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) __contacts_list_pane___lambda84__gtk_button_clicked, self, 0);
#line 96 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	return obj;
#line 700 "contacts-list-pane.c"
}


static void contacts_list_pane_class_init (ContactsListPaneClass * klass) {
	gint ContactsListPane_private_offset;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_parent_class = g_type_class_peek_parent (klass);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_type_class_add_private (klass, sizeof (ContactsListPanePrivate));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) contacts_list_pane_real_get_preferred_width;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_list_pane_get_property;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_list_pane_set_property;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->constructor = contacts_list_pane_constructor;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_list_pane_finalize;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_LIST_PANE_STORE, contacts_list_pane_properties[CONTACTS_LIST_PANE_STORE] = g_param_spec_object ("store", "store", "store", CONTACTS_TYPE_STORE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	ContactsListPane_private_offset = g_type_class_get_instance_private_offset (klass);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/contacts/ui/contacts-list-pane.ui");
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL] = g_signal_new ("link-contacts", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_LINKED_LIST);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL] = g_signal_new ("delete-contacts", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_LINKED_LIST);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL] = g_signal_new ("contacts-marked", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contacts_view", FALSE, ContactsListPane_private_offset + G_STRUCT_OFFSET (ContactsListPanePrivate, contacts_view));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_tool_item", FALSE, G_STRUCT_OFFSET (ContactsListPane, search_tool_item));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "filter_entry", FALSE, G_STRUCT_OFFSET (ContactsListPane, filter_entry));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "link_button", FALSE, G_STRUCT_OFFSET (ContactsListPane, link_button));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, G_STRUCT_OFFSET (ContactsListPane, delete_button));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "actions_bar", FALSE, G_STRUCT_OFFSET (ContactsListPane, actions_bar));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "filter_entry_changed", G_CALLBACK(_contacts_list_pane_filter_entry_changed_gtk_editable_changed));
#line 748 "contacts-list-pane.c"
}


static void contacts_list_pane_instance_init (ContactsListPane * self) {
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self->priv = CONTACTS_LIST_PANE_GET_PRIVATE (self);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	g_type_ensure (CONTACTS_TYPE_VIEW);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 759 "contacts-list-pane.c"
}


static void contacts_list_pane_finalize (GObject * obj) {
	ContactsListPane * self;
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 25 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->_store);
#line 37 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->contacts_view);
#line 40 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->search_tool_item);
#line 43 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->filter_entry);
#line 46 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->link_button);
#line 49 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->delete_button);
#line 52 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	_g_object_unref0 (self->actions_bar);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	G_OBJECT_CLASS (contacts_list_pane_parent_class)->finalize (obj);
#line 783 "contacts-list-pane.c"
}


GType contacts_list_pane_get_type (void) {
	static volatile gsize contacts_list_pane_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_list_pane_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsListPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_list_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsListPane), 0, (GInstanceInitFunc) contacts_list_pane_instance_init, NULL };
		GType contacts_list_pane_type_id;
		contacts_list_pane_type_id = g_type_register_static (gtk_frame_get_type (), "ContactsListPane", &g_define_type_info, 0);
		g_once_init_leave (&contacts_list_pane_type_id__volatile, contacts_list_pane_type_id);
	}
	return contacts_list_pane_type_id__volatile;
}


static void _vala_contacts_list_pane_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ContactsListPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	switch (property_id) {
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		case CONTACTS_LIST_PANE_STORE:
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		g_value_set_object (value, contacts_list_pane_get_store (self));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		break;
#line 810 "contacts-list-pane.c"
		default:
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		break;
#line 816 "contacts-list-pane.c"
	}
}


static void _vala_contacts_list_pane_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ContactsListPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
	switch (property_id) {
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		case CONTACTS_LIST_PANE_STORE:
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		contacts_list_pane_set_store (self, g_value_get_object (value));
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		break;
#line 832 "contacts-list-pane.c"
		default:
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/home/mcatanzaro/Projects/GNOME/gnome-contacts/src/contacts-list-pane.vala"
		break;
#line 838 "contacts-list-pane.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



